function h = SVAR_CSV(Ystar,h,sigh, phih)
T = size(h,1);
n = size( reshape(Ystar, [], T) , 1 );
Tn = T*n;

%% normal mixture
pi = [0.0073 .10556 .00002 .04395 .34001 .24566 .2575];
mi = [-10.12999 -3.97281 -8.56686 2.77786 .61942 1.79518 -1.08819] - 1.2704;  %% means already adjusted!! %%
sigi = [5.79596 2.61369 5.17950 .16735 .64009 .34023 1.26261];
sqrtsigi = sqrt(sigi);

%% sample S from a 7-point distrete distribution
temprand = rand(Tn,1);
q = repmat(pi,Tn,1).*normpdf(repmat(Ystar,1,7),repmat(kron(h, ones(n,1)),1,7) + repmat(mi,Tn,1), repmat(sqrtsigi,Tn,1));
q = q./repmat(sum(q,2),1,7);
S = 1 + sum( cumsum(q,2) < repmat(temprand,1,7), 2 );
    
%% sample h
Xh = kron(speye(T), ones(n,1));
Hh = speye(T) - phih*sparse(2:T, 1:T-1, ones(T-1,1), T, T);
invOmegah = sparse(1:T,1:T, [(1-phih^2)/sigh; 1/sigh*ones(T-1,1)], T, T);
dconst = mi(S)'; 
invOmegaYstar = sparse(1:Tn, 1:Tn, 1./sigi(S)', Tn, Tn);
invDh = Hh'*invOmegah*Hh + Xh'*invOmegaYstar*Xh;
Ch = chol(invDh, 'lower');
hhat = Ch'\(Ch\( Xh'*invOmegaYstar*(Ystar - dconst) ));
h = hhat + Ch'\randn(T,1);

