%% VAR-SV (forecasting)

%% construct Y, X
Y = Data(p+loff:end,:);
[T,n] = size(Y);
kbeta = n*n*p + n;         % no. of parameter in beta
kgam = n*(n - 1)/2;        % no. of parameter in gamma_t
X = zeros(T,n*p);
for ii = 1:p
    X(:, (ii-1)*n + 1 : ii*n ) = Data( p - ii + 1 : end-ii-loff+1, :); 
end
X = [ones(T,1) X];

%% construct W
idi = triu( repmat(2:n, n-1, 1) );
idi = reshape(idi,[],1);
idi(idi == 0) = [];
idj = (1:kgam)';
idw = triu( repmat( (1:n-1)', 1, n-1 ) );
idw = reshape(idw,[],1);
idw(idw == 0) = [];

for ii = 1:T 
    if ii == 1
        wt = Y(ii,:);
        W = -sparse(idi, idj, wt(idw), n, kgam);
    else
        wt = Y(ii,:);
        tempWt = -sparse(idi, idj, wt(idw), n, kgam);
        W = blkdiag(W, tempWt);
    end
end

%% forecasting evaluation periord
dates = dates(end-T+1:end);
T0 = find(round(dates,3) == round(startingdate,3));

%% store forecast estimates
% individual forecast estimates
yhat1  = zeros(T-1-T0+1,3,5);       %% h=1; 
yhat2  = zeros(T-2-T0+1,3,5);       %% h=2; 
yhat3  = zeros(T-3-T0+1,3,5);       %% h=3; 
yhat4  = zeros(T-4-T0+1,3,5);       %% h=4;
yhat5  = zeros(T-5-T0+1,3,5);       %% h=5; 
yhat6  = zeros(T-6-T0+1,3,5);       %% h=6; 
yhat7  = zeros(T-7-T0+1,3,5);       %% h=7; 
yhat8  = zeros(T-8-T0+1,3,5);       %% h=8; 
yhat9  = zeros(T-9-T0+1,3,5);       %% h=9
yhat10  = zeros(T-10-T0+1,3,5);     %% h=10; 
yhat11  = zeros(T-11-T0+1,3,5);     %% h=11; 
yhat12  = zeros(T-12-T0+1,3,5);     %% h=12;         
tempyhat1 = zeros(nsims,3,3);         
tempyhat2 = zeros(nsims,3,3);
tempyhat3 = zeros(nsims,3,3);
tempyhat4 = zeros(nsims,3,3);
tempyhat5 = zeros(nsims,3,3);
tempyhat6 = zeros(nsims,3,3);
tempyhat7 = zeros(nsims,3,3);
tempyhat8 = zeros(nsims,3,3);
tempyhat9 = zeros(nsims,3,3);
tempyhat10 = zeros(nsims,3,3);
tempyhat11 = zeros(nsims,3,3);
tempyhat12 = zeros(nsims,3,3);
% joint forecast estimates
Jyhat1  = zeros(T-1-T0+1,1);          %% h=1
Jyhat2  = zeros(T-2-T0+1,1);          %% h=2; 
Jyhat3  = zeros(T-3-T0+1,1);          %% h=3; 
Jyhat4  = zeros(T-4-T0+1,1);          %% h=4; 
Jyhat5  = zeros(T-5-T0+1,1);          %% h=5; 
Jyhat6  = zeros(T-6-T0+1,1);          %% h=6; 
Jyhat7  = zeros(T-7-T0+1,1);          %% h=7; 
Jyhat8  = zeros(T-8-T0+1,1);          %% h=8; 
Jyhat9  = zeros(T-9-T0+1,1);          %% h=9; 
Jyhat10  = zeros(T-10-T0+1,1);        %% h=10; 
Jyhat11  = zeros(T-11-T0+1,1);        %% h=11; 
Jyhat12 = zeros(T-12-T0+1,1);         %% h=12;  
Jtempyhat1 = zeros(nsims,1);
Jtempyhat2 = zeros(nsims,1);
Jtempyhat3 = zeros(nsims,1);
Jtempyhat4 = zeros(nsims,1);
Jtempyhat5 = zeros(nsims,1);
Jtempyhat6 = zeros(nsims,1);
Jtempyhat7 = zeros(nsims,1);
Jtempyhat8 = zeros(nsims,1);
Jtempyhat9 = zeros(nsims,1);
Jtempyhat10 = zeros(nsims,1);
Jtempyhat11 = zeros(nsims,1);
Jtempyhat12 = zeros(nsims,1);
% % store BIC, DIC, ML
% store_maxllike = zeros(T-1-T0+1,1);
% store_DIC = zeros(T-1-T0+1,1);
% store_logML = zeros(T-1-T0+1,1);

%% priors 
construct_shrikageprior;
% beta0 = zeros(kbeta,1); Vbeta = 10*ones(kbeta,1);
agam = zeros(kgam,1); Vgam = 10*ones(kgam,1);
ah = zeros(n,1); Vh = 10*ones(n,1);
nugam0 = 10*ones(kgam,1); Sgam0 = .01^2*ones(kgam,1).*(nugam0-1); 
nuh0 = 10*ones(n,1); Sh0 = .1^2*ones(n,1).*(nuh0-1);

for t = T0:T-loff
    Tt = t;
    Xt = X(1:t,:);
    Yt = Y(1:t,:);
    Xtildet = SURform2(Xt,n);
    longYt = reshape(Yt',[],1);
    Wt = W(1:t*n, 1:t*kgam);
    
    %% initialize   
    beta = (Xtildet'*Xtildet)\(Xtildet'*longYt);
    Siggam = .01*ones(kgam,1);
    Sigh = .01*ones(n,1);
    h0 = log(var(Yt))';
    h = repmat(h0',Tt,1);
    gam0 = zeros(kgam,1);
    
%     %% store outputs
%     store_Siggam = zeros(nsims,kgam); 
%     store_Sigh = zeros(nsims,n);
%     store_beta = zeros(nsims,kbeta); 
%     store_gam = zeros(nsims,Tt*kgam); 
%     store_gam0 = zeros(nsims,kgam);
%     store_h = zeros(nsims,Tt*n);
%     store_h0 = zeros(nsims,n);
%     
    %% outside the loop
    Hgam = speye(Tt*kgam) - sparse(kgam+1: Tt*kgam, 1: (Tt-1)*kgam, ones((Tt-1)*kgam,1), Tt*kgam, Tt*kgam);
    icov = triu(repmat(2:n, n-1, 1));
    icov = reshape(icov,[],1);
    icov(icov == 0) = [];
    jcov = triu( repmat( (1:n-1)', 1, n-1 ) );
    jcov = reshape(jcov,[],1);
    jcov(jcov == 0 ) = [];
    
    for isim = 1:nsims + burnin    
        %% sample gam    
        invSig = sparse(1:Tt*n,1:Tt*n,reshape(exp(-h)',Tt*n,1)); 
        invS = sparse(1:Tt*kgam,1:Tt*kgam,repmat(1./Siggam',1,Tt));
        WinvSig = Wt'*invSig;
        HinvSH = Hgam'*invS*Hgam;
        alpgam = Hgam\[gam0;sparse((Tt-1)*kgam,1)];   
        Kgam = HinvSH + WinvSig*Wt;    
        gamhat = Kgam\(HinvSH*alpgam + WinvSig*(longYt-Xtildet*beta));
        gam = gamhat + chol(Kgam,'lower')'\randn(Tt*kgam,1);

        %% sample beta    
        XtildeinvSig = Xtildet'*invSig;
        Kbeta = sparse(1:kbeta,1:kbeta,1./Vbeta) + XtildeinvSig*Xtildet;
        betahat = Kbeta\(beta0./Vbeta + XtildeinvSig*(longYt-Wt*gam));
        betai = betahat + chol(Kbeta,'lower')'\randn(kbeta,1);
        % check stationary
        Beta = reshape(betai,[],n)';
        Beta = Beta(:,2:end);
        Comp = [Beta; speye(n*(p-1)) zeros(n*(p-1),n)];
        
        opts.tol = 1e-3;
        if  abs(eigs(Comp,1,'lm',opts)) < 1 && abs(eigs(Comp,1,'sm',opts)) < 1
            beta = betai;
        end

        %% sample gam0
        Kgam0 = sparse(1:kgam,1:kgam,1./Siggam + 1./Vgam);
        gam0hat = Kgam0\(agam./Vgam + gam(1:kgam)./Siggam);
        gam0 = gam0hat + chol(Kgam0,'lower')'\randn(kgam,1);

        %% sample h  
        u = longYt-Xtildet*beta - Wt*gam;
        shortu = reshape(u,n,Tt)';
        for i=1:n
            Ystar = log(shortu(:,i).^2 + .0001 );
            h(:,i) = SVRW(Ystar,h(:,i),Sigh(i),h0(i));
        end    

        %% sample h0
        Kh0 = sparse(1:n,1:n,1./Sigh + 1./Vh);
        h0hat = Kh0\(ah./Vh + h(1,:)'./Sigh);
        h0 = h0hat + chol(Kh0,'lower')'\randn(n,1);

        %% sample Siggam
        e = reshape(gam-[gam0;gam(1:(Tt-1)*kgam)],kgam,Tt);
        Siggam = 1./gamrnd(nugam0+Tt/2, 1./(Sgam0 + sum(e.^2,2)/2));

        %% sample Sigh
        e = h - [h0';h(1:Tt-1,:)];
        Sigh = 1./gamrnd(nuh0+T/2, 1./(Sh0 + sum(e.^2)'/2));

        if isim>burnin
            i = isim-burnin;            
            
%             store_beta(i,:) = beta';
%             store_gam(i,:) = gam';
%             store_h(i,:) = reshape(h',1,Tt*n); 
%             store_Siggam(i,:) = Siggam';
%             store_Sigh(i,:) = Sigh';
%             store_gam0(i,:) = gam0';
%             store_h0(i,:) = h0';       
%             
            %%%%%%%%%%%%%% store forecast estimates
            fX1 = X(t+loff,:); fX2 = X(t+loff,:);
            fbeta1 = beta; fbeta2 = beta;
            fgam1 = gam(end-kgam+1:end); fgam2 = gam(end-kgam+1:end);
            fh1 = h(end,:)'; fh2 = h(end,:)';
            fSigh1 = Sigh;  fSigh2 = Sigh;
            fSiggam1 = Siggam; fSiggam2 = Siggam;
            
            for count = 1:loff
                fgam1 = fgam1 + sqrt(fSiggam1).*randn(kgam,1);
                fh1 = fh1 + sqrt(fSigh1).*randn(n,1);
            end
            B = speye(n) + sparse(icov, jcov, fgam1, n, n);
            invB = B\speye(n);
            fSig1 = invB*sparse(1:n,1:n, exp(fh1))*invB';
            ym1 = invB*kron(speye(n),fX1)*fbeta1;
            yhat_1 = ym1 + chol(fSig1, 'lower')*randn(n,1);
            fX1 = [1 yhat_1' fX1(2:end-n)];
            yhat_c1 = yhat_1(1:3);

            for count = 1:loff
                fgam2 = fgam2 + sqrt(fSiggam2).*randn(kgam,1);
                fh2 = fh2 + sqrt(fSigh2).*randn(n,1);
            end
            B = speye(n) + sparse(icov, jcov, fgam2, n, n);
            invB = B\speye(n);
            fSig2 = invB*sparse(1:n,1:n, exp(fh2))*invB';
            ym2 = invB*kron(speye(n),fX2)*fbeta2;
            yhat_2 = ym2 + chol(fSig2, 'lower')*randn(n,1);
            fX2 = [1 yhat_2' fX2(2:end-n)];
            yhat_c2 = yhat_2(1:3);

            crps1 = abs(yhat_c1 - Y(t+loff,1:3)') - .5*abs(yhat_c1 - yhat_c2);
            tempyhat1(i,:,:) = [yhat_c1(1:3) normpdf( Y(t+loff,1:3)', ym1(1:3), sqrt(diag(fSig1(1:3,1:3))) )  crps1];
            Jtempyhat1(i) = mvnpdf( Y(t+loff,1:3), ym1(1:3)', fSig1(1:3,1:3) );
        end

        if ( mod( isim, 1000 ) == 0 )
            disp(  [ num2str( nsims + burnin - isim ) ' MCMC iterations remained... ' ] )
        end 

    end
    %%%%%%%%%%%%%%% compute forecast estimates
    yhat1(t-T0+1,:,:) = [Y(t+loff,1:3)' reshape(mean(tempyhat1(:,:,1)),[],1)  reshape(log(mean(tempyhat1(:,:,2))),[],1) reshape(median(tempyhat1(:,:,1)),[],1) reshape(mean(tempyhat1(:,:,3)),[],1)];
    Jyhat1(t-T0+1) = log(mean(Jtempyhat1)); 
    
    if ( mod( t, 1 ) == 0 )
        disp(  [ num2str( T-1-t ) ' forecast loops remained ........ ' ] ) 
    end 
end

RMSFE = zeros(3,12);
ALPS = zeros(3,12);
MAE = zeros(3,12);
ACRPS = zeros(3,12);

disp('...........Root Mean Square Forecast Errors(mean)................. ')
RMSFE(:,1) = sqrt(mean((yhat1(:,:,1) - yhat1(:,:,2)).^2, 1))';
RMSFE(:,2) = sqrt(mean((yhat2(:,:,1) - yhat2(:,:,2)).^2, 1))';
RMSFE(:,3) = sqrt(mean((yhat3(:,:,1) - yhat3(:,:,2)).^2, 1))';
RMSFE(:,4) = sqrt(mean((yhat4(:,:,1) - yhat4(:,:,2)).^2, 1))';
RMSFE(:,5) = sqrt(mean((yhat5(:,:,1) - yhat5(:,:,2)).^2, 1))';
RMSFE(:,6) = sqrt(mean((yhat6(:,:,1) - yhat6(:,:,2)).^2, 1))';
RMSFE(:,7) = sqrt(mean((yhat7(:,:,1) - yhat7(:,:,2)).^2, 1))';
RMSFE(:,8) = sqrt(mean((yhat8(:,:,1) - yhat8(:,:,2)).^2, 1))';
RMSFE(:,9) = sqrt(mean((yhat9(:,:,1) - yhat9(:,:,2)).^2, 1))';
RMSFE(:,10) = sqrt(mean((yhat10(:,:,1) - yhat10(:,:,2)).^2, 1))';
RMSFE(:,11) = sqrt(mean((yhat11(:,:,1) - yhat11(:,:,2)).^2, 1))';
RMSFE(:,12) = sqrt(mean((yhat12(:,:,1) - yhat12(:,:,2)).^2, 1))';
RMSFE

disp('...............Average Log Predictive likelihoods................. ')
ALPS(:,1) = mean(yhat1(:,:,3),1)';
ALPS(:,2) = mean(yhat2(:,:,3),1)';
ALPS(:,3) = mean(yhat3(:,:,3),1)';
ALPS(:,4) = mean(yhat4(:,:,3),1)';
ALPS(:,5) = mean(yhat5(:,:,3),1)';
ALPS(:,6) = mean(yhat6(:,:,3),1)';
ALPS(:,7) = mean(yhat7(:,:,3),1)';
ALPS(:,8) = mean(yhat8(:,:,3),1)';
ALPS(:,9) = mean(yhat9(:,:,3),1)';
ALPS(:,10) = mean(yhat10(:,:,3),1)';
ALPS(:,11) = mean(yhat11(:,:,3),1)';
ALPS(:,12) = mean(yhat12(:,:,3),1)';
ALPS

disp('...............Mean Absolute Error(median)........................ ')
MAE(:,1) = mean(abs(yhat1(:,:,1) - yhat1(:,:,4)))';
MAE(:,2) = mean(abs(yhat2(:,:,1) - yhat2(:,:,4)))';
MAE(:,3) = mean(abs(yhat3(:,:,1) - yhat3(:,:,4)))';
MAE(:,4) = mean(abs(yhat4(:,:,1) - yhat4(:,:,4)))';
MAE(:,5) = mean(abs(yhat5(:,:,1) - yhat5(:,:,4)))';
MAE(:,6) = mean(abs(yhat6(:,:,1) - yhat6(:,:,4)))';
MAE(:,7) = mean(abs(yhat7(:,:,1) - yhat7(:,:,4)))';
MAE(:,8) = mean(abs(yhat8(:,:,1) - yhat8(:,:,4)))';
MAE(:,9) = mean(abs(yhat9(:,:,1) - yhat9(:,:,4)))';
MAE(:,10) = mean(abs(yhat10(:,:,1) - yhat10(:,:,4)))';
MAE(:,11) = mean(abs(yhat11(:,:,1) - yhat11(:,:,4)))';
MAE(:,12) = mean(abs(yhat12(:,:,1) - yhat12(:,:,4)))';
MAE

disp('............Average Continous Ranked Probability Score............ ')
ACRPS(:,1) = mean(yhat1(:,:,5))';
ACRPS(:,2) = mean(yhat2(:,:,5))';
ACRPS(:,3) = mean(yhat3(:,:,5))';
ACRPS(:,4) = mean(yhat4(:,:,5))';
ACRPS(:,5) = mean(yhat5(:,:,5))';
ACRPS(:,6) = mean(yhat6(:,:,5))';
ACRPS(:,7) = mean(yhat7(:,:,5))';
ACRPS(:,8) = mean(yhat8(:,:,5))';
ACRPS(:,9) = mean(yhat9(:,:,5))';
ACRPS(:,10) = mean(yhat10(:,:,5))';
ACRPS(:,11) = mean(yhat11(:,:,5))';
ACRPS(:,12) = mean(yhat12(:,:,5))';
ACRPS




[mean(Jyhat1) mean(Jyhat2) mean(Jyhat3) mean(Jyhat4) mean(Jyhat5) mean(Jyhat6) mean(Jyhat7) mean(Jyhat8) mean(Jyhat9) mean(Jyhat10) mean(Jyhat11) mean(Jyhat12)]












