%% shrikage prior

% prior mean
beta0 = zeros(kbeta,1);

% hyperparameters
c1 = 0.2; % overall tightness 
c2 = 0.5; % additional shrinkage on lags of other variables than for lags of the dependent variable
c3 = 2;   % rate at wichi the prior variance decreases with increases lag length

% intercept 
vc0 = 10*ones(n,1);

% VAR coefficient
sqrtsig = zeros(n,1);
for i = 1:n
    yi = Y(:,i);
    Xi = [ones(T,1) X(:, (i+1):n:n*p )];
    e = yi - Xi*( (Xi'*Xi)\(Xi'*yi) );
    sqrtsig(i) = sqrt( mean(e.^2) );
end

sig_ratio = sqrtsig*(1./sqrtsig)';
C1 = 1./(  kron((1:p),ones(n,n)).^c3 );
C2 = repmat(sig_ratio, 1, p);
C3 = c2*ones(n);
C3(logical(eye(n))) = 0;
C3 = repmat( speye(n) + C3, 1, p);
vPhi = c1^2.*C1.*C2.*C3;

Vbeta = reshape([vc0 vPhi]',[],1);

