%% large_VAR_Homo forecasting

%% construct Y, X, W (sorting data)
Y = Data(p+loff:end,:);
longY = reshape(Y',[],1);
[T,n] = size(Y);
np = n*p;                  % no. of parameters in each equation without including intercept
kbeta = n*n*p + n;         % no. of parameter in beta_t
kgam = n*(n - 1)/2;        % no. of parameter in gamma_t
k = np + 1;                % no. of parameters in each equation without including intercept
X = zeros(T,np);
for ii = 1:p
    X(:, (ii-1)*n + 1 : ii*n) = Data(p - ii + 1 : end-ii-loff+1, :); 
end
X = [ones(T,1) X];

%% construct BigW
idi = triu( repmat(2:n, n-1, 1) );
idi = reshape(idi,[],1);
idi(idi == 0) = [];
idj = (1:kgam)';
idw = triu( repmat( (1:n-1)', 1, n-1 ) );
idw = reshape(idw,[],1);
idw(idw == 0) = [];

for ii = 1:T 
    if ii == 1
        w = Y(ii,:);
        BigW = -sparse(idi, idj, w(idw), n, kgam);
    else
        w = Y(ii,:);
        W = -sparse(idi, idj, w(idw), n, kgam);
        BigW = [BigW; W];
    end
end

%% forecasting evaluation periord
dates = dates(end-T+1:end);
T0 = find(round(dates,3) == round(startingdate,3));

%% store forecast estimates
% individual forecast estimates
yhat1  = zeros(T-1-T0+1,3,5);       %% h=1; 
yhat2  = zeros(T-2-T0+1,3,5);       %% h=2; 
yhat3  = zeros(T-3-T0+1,3,5);       %% h=3; 
yhat4  = zeros(T-4-T0+1,3,5);       %% h=4;
yhat5  = zeros(T-5-T0+1,3,5);       %% h=5; 
yhat6  = zeros(T-6-T0+1,3,5);       %% h=6; 
yhat7  = zeros(T-7-T0+1,3,5);       %% h=7; 
yhat8  = zeros(T-8-T0+1,3,5);       %% h=8; 
yhat9  = zeros(T-9-T0+1,3,5);       %% h=9
yhat10  = zeros(T-10-T0+1,3,5);     %% h=10; 
yhat11  = zeros(T-11-T0+1,3,5);     %% h=11; 
yhat12  = zeros(T-12-T0+1,3,5);     %% h=12;         
tempyhat1 = zeros(nsims,3,3);         
tempyhat2 = zeros(nsims,3,3);
tempyhat3 = zeros(nsims,3,3);
tempyhat4 = zeros(nsims,3,3);
tempyhat5 = zeros(nsims,3,3);
tempyhat6 = zeros(nsims,3,3);
tempyhat7 = zeros(nsims,3,3);
tempyhat8 = zeros(nsims,3,3);
tempyhat9 = zeros(nsims,3,3);
tempyhat10 = zeros(nsims,3,3);
tempyhat11 = zeros(nsims,3,3);
tempyhat12 = zeros(nsims,3,3);
% joint forecast estimates
Jyhat1  = zeros(T-1-T0+1,1);          %% h=1
Jyhat2  = zeros(T-2-T0+1,1);          %% h=2; 
Jyhat3  = zeros(T-3-T0+1,1);          %% h=3; 
Jyhat4  = zeros(T-4-T0+1,1);          %% h=4; 
Jyhat5  = zeros(T-5-T0+1,1);          %% h=5; 
Jyhat6  = zeros(T-6-T0+1,1);          %% h=6; 
Jyhat7  = zeros(T-7-T0+1,1);          %% h=7; 
Jyhat8  = zeros(T-8-T0+1,1);          %% h=8; 
Jyhat9  = zeros(T-9-T0+1,1);          %% h=9; 
Jyhat10  = zeros(T-10-T0+1,1);        %% h=10; 
Jyhat11  = zeros(T-11-T0+1,1);        %% h=11; 
Jyhat12 = zeros(T-12-T0+1,1);         %% h=12;  
Jtempyhat1 = zeros(nsims,1);
Jtempyhat2 = zeros(nsims,1);
Jtempyhat3 = zeros(nsims,1);
Jtempyhat4 = zeros(nsims,1);
Jtempyhat5 = zeros(nsims,1);
Jtempyhat6 = zeros(nsims,1);
Jtempyhat7 = zeros(nsims,1);
Jtempyhat8 = zeros(nsims,1);
Jtempyhat9 = zeros(nsims,1);
Jtempyhat10 = zeros(nsims,1);
Jtempyhat11 = zeros(nsims,1);
Jtempyhat12 = zeros(nsims,1);

%% priors
% beta0 = zeros(kb,1);
% invVbeta0 = 1/10*speye(kb);
construct_shrikageprior;
beta0 = reshape(beta0, n, k); 
Vbeta = [vc0 vPhi];
gam0 = zeros(kgam,1); 
Vgam0 = 1/5*ones(kgam,1);
nu0 = 10;
S0 = (nu0-1);

for t = T0:T-loff
    Tt = t;
    Xt = X(1:t,:);
    Yt = Y(1:t,:);
    longYt = reshape(Yt',[],1);
    BigWt = BigW(1:n*Tt,1:kgam);  
    %% initialization 
    gam = zeros(kgam,1);
    sigy = ones(n,1);
    Beta = zeros(n,k);
    %% outside the loop
    icov = triu(repmat(2:n, n-1, 1));
    icov = reshape(icov,[],1);
    icov(icov == 0) = [];
    jcov = triu( repmat( (1:n-1)', 1, n-1 ) );
    jcov = reshape(jcov,[],1);
    jcov(jcov == 0 ) = [];
    
    for isim = 1:nsims + burnin         
        %% sample beta
        Ybeta = reshape( longYt - BigWt*gam, n, [] );
        for i = 1:n
            yi = Ybeta(i,:)'; 
            beta0i = beta0(i,:)';
            Vbetai = Vbeta(i,:)';
            sigyi = sigy(i);
            Kbetai = sparse(1:k,1:k,1./Vbetai) + Xt'*Xt/sigyi;
            C = chol(Kbetai,'lower');
            betai = C'\( C\(beta0i./Vbetai + Xt'*yi/sigyi) + randn(k,1) );
            Beta(i,:) = betai';
        end
        %% sample gam
        WinvSig = BigWt'*sparse(1:Tt*n,1:Tt*n,repmat(1./sigy, Tt, 1));
        Kgam = sparse(1:kgam,1:kgam,1./Vgam0) + WinvSig*BigWt;
        C = chol(Kgam, 'lower');
        gam = C'\( C\(gam0./Vgam0 + WinvSig*reshape( Yt' - Beta*Xt',[], 1) ) + randn(kgam,1) );
        %% sample sigy
        err = Yt - Xt*Beta' - reshape(BigWt*gam, n, Tt)'; 
        sigy = 1./gamrnd(nu0 + Tt/2, 1./(S0 + sum(err.^2)'/2));  
       
        if isim>burnin
            i = isim-burnin;
            
            fX1 = X(t+loff,:); fX2 = X(t+loff,:);           
            invB = (speye(n) + sparse(icov, jcov, gam, n, n))\speye(n);
            Sigy = invB*sparse(1:n,1:n, sigy)*invB';
            Sigy = 0.5*(Sigy + Sigy');
            
            ym1 = invB*Beta*fX1';
            yhat_1 = ym1 + invB*(sqrt(sigy).*randn(n,1));
            fX1 = [1 yhat_1' fX1(2:end-n)];
            yhat_c1 = yhat_1(1:3);

            ym2 = invB*Beta*fX2';
            yhat_2 = ym2 + invB*(sqrt(sigy).*randn(n,1));
            fX2 = [1 yhat_2' fX2(2:end-n)];
            yhat_c2 = yhat_2(1:3);

            crps1 = abs(yhat_c1 - Y(t+loff,1:3)') - .5*abs(yhat_c1 - yhat_c2);
            tempyhat1(i,:,:) = [yhat_c1(1:3) normpdf( Y(t+loff,1:3)', ym1(1:3), sqrt(diag(Sigy(1:3,1:3))) )  crps1];
            Jtempyhat1(i) = mvnpdf( Y(t+loff,1:3), ym1(1:3)', Sigy(1:3,1:3) );
        end

        if ( mod( isim, 1000 ) == 0 )
            disp(  [ num2str( nsims + burnin - isim ) ' MCMC iterations remained... ' ] )
        end 

    end
    %%%%%%%%%%%%%%% compute forecast estimates
    yhat1(t-T0+1,:,:) = [Y(t+loff,1:3)' reshape(mean(tempyhat1(:,:,1)),[],1)  reshape(log(mean(tempyhat1(:,:,2))),[],1) reshape(median(tempyhat1(:,:,1)),[],1) reshape(mean(tempyhat1(:,:,3)),[],1)];
    Jyhat1(t-T0+1) = log(mean(Jtempyhat1)); 
    
    if ( mod( t, 1 ) == 0 )
        disp(  [ num2str( T-1-t ) ' forecast loops remained ........ ' ] ) 
    end 
end

RMSFE = zeros(3,12);
ALPS = zeros(3,12);
MAE = zeros(3,12);
ACRPS = zeros(3,12);

disp('...........Root Mean Square Forecast Errors(mean)................. ')
RMSFE(:,1) = sqrt(mean((yhat1(:,:,1) - yhat1(:,:,2)).^2, 1))';
RMSFE(:,2) = sqrt(mean((yhat2(:,:,1) - yhat2(:,:,2)).^2, 1))';
RMSFE(:,3) = sqrt(mean((yhat3(:,:,1) - yhat3(:,:,2)).^2, 1))';
RMSFE(:,4) = sqrt(mean((yhat4(:,:,1) - yhat4(:,:,2)).^2, 1))';
RMSFE(:,5) = sqrt(mean((yhat5(:,:,1) - yhat5(:,:,2)).^2, 1))';
RMSFE(:,6) = sqrt(mean((yhat6(:,:,1) - yhat6(:,:,2)).^2, 1))';
RMSFE(:,7) = sqrt(mean((yhat7(:,:,1) - yhat7(:,:,2)).^2, 1))';
RMSFE(:,8) = sqrt(mean((yhat8(:,:,1) - yhat8(:,:,2)).^2, 1))';
RMSFE(:,9) = sqrt(mean((yhat9(:,:,1) - yhat9(:,:,2)).^2, 1))';
RMSFE(:,10) = sqrt(mean((yhat10(:,:,1) - yhat10(:,:,2)).^2, 1))';
RMSFE(:,11) = sqrt(mean((yhat11(:,:,1) - yhat11(:,:,2)).^2, 1))';
RMSFE(:,12) = sqrt(mean((yhat12(:,:,1) - yhat12(:,:,2)).^2, 1))';
RMSFE

disp('...............Average Log Predictive likelihoods................. ')
ALPS(:,1) = mean(yhat1(:,:,3),1)';
ALPS(:,2) = mean(yhat2(:,:,3),1)';
ALPS(:,3) = mean(yhat3(:,:,3),1)';
ALPS(:,4) = mean(yhat4(:,:,3),1)';
ALPS(:,5) = mean(yhat5(:,:,3),1)';
ALPS(:,6) = mean(yhat6(:,:,3),1)';
ALPS(:,7) = mean(yhat7(:,:,3),1)';
ALPS(:,8) = mean(yhat8(:,:,3),1)';
ALPS(:,9) = mean(yhat9(:,:,3),1)';
ALPS(:,10) = mean(yhat10(:,:,3),1)';
ALPS(:,11) = mean(yhat11(:,:,3),1)';
ALPS(:,12) = mean(yhat12(:,:,3),1)';
ALPS

disp('...............Mean Absolute Error(median)........................ ')
MAE(:,1) = mean(abs(yhat1(:,:,1) - yhat1(:,:,4)))';
MAE(:,2) = mean(abs(yhat2(:,:,1) - yhat2(:,:,4)))';
MAE(:,3) = mean(abs(yhat3(:,:,1) - yhat3(:,:,4)))';
MAE(:,4) = mean(abs(yhat4(:,:,1) - yhat4(:,:,4)))';
MAE(:,5) = mean(abs(yhat5(:,:,1) - yhat5(:,:,4)))';
MAE(:,6) = mean(abs(yhat6(:,:,1) - yhat6(:,:,4)))';
MAE(:,7) = mean(abs(yhat7(:,:,1) - yhat7(:,:,4)))';
MAE(:,8) = mean(abs(yhat8(:,:,1) - yhat8(:,:,4)))';
MAE(:,9) = mean(abs(yhat9(:,:,1) - yhat9(:,:,4)))';
MAE(:,10) = mean(abs(yhat10(:,:,1) - yhat10(:,:,4)))';
MAE(:,11) = mean(abs(yhat11(:,:,1) - yhat11(:,:,4)))';
MAE(:,12) = mean(abs(yhat12(:,:,1) - yhat12(:,:,4)))';
MAE

disp('............Average Continous Ranked Probability Score............ ')
ACRPS(:,1) = mean(yhat1(:,:,5))';
ACRPS(:,2) = mean(yhat2(:,:,5))';
ACRPS(:,3) = mean(yhat3(:,:,5))';
ACRPS(:,4) = mean(yhat4(:,:,5))';
ACRPS(:,5) = mean(yhat5(:,:,5))';
ACRPS(:,6) = mean(yhat6(:,:,5))';
ACRPS(:,7) = mean(yhat7(:,:,5))';
ACRPS(:,8) = mean(yhat8(:,:,5))';
ACRPS(:,9) = mean(yhat9(:,:,5))';
ACRPS(:,10) = mean(yhat10(:,:,5))';
ACRPS(:,11) = mean(yhat11(:,:,5))';
ACRPS(:,12) = mean(yhat12(:,:,5))';
ACRPS




[mean(Jyhat1) mean(Jyhat2) mean(Jyhat3) mean(Jyhat4) mean(Jyhat5) mean(Jyhat6)...
    mean(Jyhat7) mean(Jyhat8) mean(Jyhat9) mean(Jyhat10) mean(Jyhat11) mean(Jyhat12)]






