% load data from other models (these need to be in the folder already)
load mV_VARSV;
load mV_VARHM;
load mV_CCM1;
load mV_CCM2;

% use ML and EQ for the CL models
mV_CLML = prctile( s_V{1}, [5 16 50 84 95] );
mV_CLEQ = prctile( s_V{end}, [5 16 50 84 95] );

% make a plot with point forecasts
figure( 'Units', 'centimeters', 'Position', [0.0 0.0 20 15] );
for r = 1:ncore
    for c = r:ncore
        subplot( ncore, ncore, ( c - 1 ) * ncore + r );
        plot( dates, squeeze( mV_VARSV( 3, r, c, : ) ), '-r', ...
              dates, squeeze( mV_CLML( 3, r, c, : ) ), '-k', ...
              dates, squeeze( mV_CLEQ( 3, r, c, : ) ), '--k', ...
              dates, squeeze( mV_CCM2( 3, r, c, : ) ), '-b' );
    end
end
legend( 'VAR-SV', 'VAR-CL-ML', 'VAR-CL-EQ', 'VAR-CCM2' );

% make a plot for VARSV vs CLML
figure( 'Units', 'centimeters', 'Position', [0.0 0.0 20 15] );
for r = 1:ncore
    for c = r:ncore
        subplot( ncore, ncore, ( c - 1 ) * ncore + r );
        plot( dates, squeeze( mV_VARSV( 2, r, c, : ) ), '--r', ...
              dates, squeeze( mV_VARSV( 3, r, c, : ) ), '-r', ...
              dates, squeeze( mV_VARSV( 4, r, c, : ) ), '--r', ...
              dates, squeeze( mV_CLML( 2, r, c, : ) ), '--k', ...
              dates, squeeze( mV_CLML( 3, r, c, : ) ), '-k', ...
              dates, squeeze( mV_CLML( 4, r, c, : ) ), '--k' );
    end
end

% make a plot for VARSV vs CLEQ
figure( 'Units', 'centimeters', 'Position', [0.0 0.0 20 15] );
for r = 1:ncore
    for c = r:ncore
        subplot( ncore, ncore, ( c - 1 ) * ncore + r );
        plot( dates, squeeze( mV_VARSV( 2, r, c, : ) ), '--r', ...
              dates, squeeze( mV_VARSV( 3, r, c, : ) ), '-r', ...
              dates, squeeze( mV_VARSV( 4, r, c, : ) ), '--r', ...
              dates, squeeze( mV_CLEQ( 2, r, c, : ) ), '--k', ...
              dates, squeeze( mV_CLEQ( 3, r, c, : ) ), '-k', ...
              dates, squeeze( mV_CLEQ( 4, r, c, : ) ), '--k' );
    end
end

% make a plot for VARSV vs CCM2
figure( 'Units', 'centimeters', 'Position', [0.0 0.0 20 15] );
for r = 1:ncore
    for c = r:ncore
        subplot( ncore, ncore, ( c - 1 ) * ncore + r );
        plot( dates, squeeze( mV_VARSV( 2, r, c, : ) ), '--r', ...
              dates, squeeze( mV_VARSV( 3, r, c, : ) ), '-r', ...
              dates, squeeze( mV_VARSV( 4, r, c, : ) ), '--r', ...
              dates, squeeze( mV_CCM2( 2, r, c, : ) ), '--k', ...
              dates, squeeze( mV_CCM2( 3, r, c, : ) ), '-k', ...
              dates, squeeze( mV_CCM2( 4, r, c, : ) ), '--k' );
    end
end

% make a plot for VARSV vs CCM1
figure( 'Units', 'centimeters', 'Position', [0.0 0.0 20 15] );
for r = 1:ncore
    for c = r:ncore
        subplot( ncore, ncore, ( c - 1 ) * ncore + r );
        plot( dates, squeeze( mV_VARSV( 2, r, c, : ) ), '--r', ...
              dates, squeeze( mV_VARSV( 3, r, c, : ) ), '-r', ...
              dates, squeeze( mV_VARSV( 4, r, c, : ) ), '--r', ...
              dates, squeeze( mV_CCM1( 2, r, c, : ) ), '--k', ...
              dates, squeeze( mV_CCM1( 3, r, c, : ) ), '-k', ...
              dates, squeeze( mV_CCM1( 4, r, c, : ) ), '--k' );
    end
end

% make a plot for VARSV vs VARHM
figure( 'Units', 'centimeters', 'Position', [0.0 0.0 20 15] );
for r = 1:ncore
    for c = r:ncore
        subplot( ncore, ncore, ( c - 1 ) * ncore + r );
        plot( dates, squeeze( mV_VARSV( 2, r, c, : ) ), '--r', ...
              dates, squeeze( mV_VARSV( 3, r, c, : ) ), '-r', ...
              dates, squeeze( mV_VARSV( 4, r, c, : ) ), '--r', ...
              dates, squeeze( mV_VARHM( 2, r, c, : ) ), '--k', ...
              dates, squeeze( mV_VARHM( 3, r, c, : ) ), '-k', ...
              dates, squeeze( mV_VARHM( 4, r, c, : ) ), '--k' );
    end
end

% for j = 1:length( wCL )
%     for r = 1:ncore
%         for c = r:ncore
%             mV = prctile( squeeze( s_V{j}( :, r, c, : ) ), [16 50 84] );
%             figure, plot( dates, mV( 1, : ), '--k', ...
%                           dates, mV( 2, : ), '-r', ...
%                           dates, mV( 3, : ), '--k' );
%         end
%     end
% end