function [txtlen, ppm] = setup_progmons( doparallel, heading, niter )
%% Set up text-based and java-based progress monitors

% the following is needed ONLY on Windows
% to display progress properly; on Linux
% it has no effect (but should be left defined)
txtlen = 0;

if doparallel
    dpath = javaclasspath;
    if isempty( dpath ) || ~strcmpi( dpath, [pwd '\java'] )
        pctRunOnAll javaaddpath java;
    end
    if verLessThan( 'matlab', '8.6' )
        % this version of matlab is too old for ParforProgMon
        ppm = [];
    else
        ppm = ParforProgMon( heading, niter, 1, 500, 80 );
    end
else
    ppm = [];
end